// Example DCM modual
#include "dcm.h"

#define PRINTF  0

int     test_int = 55;
long    test_long = 666000;


void mod_init(DCM *dcm);
void print_test(DCM *dcm);
void *var_router(DCM *dcm, int var);
void *proc_router(DCM *dcm, int proc);
int return_test(void);

void mod_init(DCM *dcm)
{
  dcm->dcm_var=&var_router;
  dcm->dcm_proc=&proc_router;  
}

void *var_router(DCM *dcm, int var)
{
  if (var==0)
     {
       return(&test_int);
     }
  else if (var==1)
     {
       return(&test_long);
     }
  return(0);
}

void *proc_router(DCM *dcm, int proc)
{
  if (proc==0)
     {
       print_test(dcm);
       return(0);
     }
  else if (proc==1)
     {
       return((int *)return_test());
     }
  return(0);
}

void print_test(DCM *dcm)
{
  void (*printf_ptr)(const char *format, ...);

  printf_ptr=dcm->ext_proc(PRINTF);

  printf_ptr("Hello\n");
}

int return_test(void)
{
  return(55);
}
