// Example DCM modual
#include "dynlib.h"
#include "dcm.h"

#define PRINTF  1

void mod_init(DCM *dcm);
void print_test(DCM *dcm);
void *proc_router(DCM *dcm, int proc);

void mod_init(DCM *dcm)
{
  dcm->dcm_var=0x00000000;
  dcm->dcm_proc=&proc_router;  
}

void *proc_router(DCM *dcm, int proc)
{
  if (proc==0)
     {
       return((void *)0xBBAABBAA);
     }
  else if (proc==1)
     {
       print_test(dcm);
       return((void *)DYN_TRUE);
     }
  return((void *)DYN_FALSE);
}

void print_test(DCM *dcm)
{
  void (*printf_ptr)(const char *format, ...);

  printf_ptr=dcm->ext_proc(PRINTF);

  printf_ptr("Hello\n");
}

