@echo off
if .%1 == . goto usage
if .%2 == . goto usage

echo Creating DCM (DXE)
dxegen %1.dcm _%2 %1.o

goto end

:usage
echo   Usage:
echo.
echo      makedcm [filename] [init_function]
echo.
echo      Where [filename] is the name of the object file without the extension
echo      this name will also be used for the DCM, and [init_function] is the
echo      name of the function that does the initialization of the DCM modual
echo      without the leading underscore (example: if its named bob_init then
echo      type bob_init).
echo.

:end
