// DYNCOM Example program
//
// Self manages a DCM usage operation
//
#include <stdio.h>
#include "dyncom.h"


void *ex_proc_handler(int proc);

void main(void)
{
  DCM   *ex_dcm;

  int   t1, *t2;
  long  *lt1;

  ex_dcm=Load_DCM("example.dcm", &ex_proc_handler, NULL);

  ex_dcm->dcm_proc(ex_dcm, 0);  // print test
  
  t1=(int)ex_dcm->dcm_proc(ex_dcm, 1);       // return test


  t2=ex_dcm->dcm_var(ex_dcm, 0);        // return int
  lt1=ex_dcm->dcm_var(ex_dcm, 1);       // return long

  printf("t1: %d    t2: %d    lt1: %ld", t1, *t2, *lt1);

  Free_DCM(ex_dcm);
}

void *ex_proc_handler(int proc)
{
  if (proc==0)
     {
       return(&printf);
     }
  return(0);
}
