#include <stdio.h>
#include "dynlib.h"

#define PRINT_TEST      1       // example2's print test function number

void *proc_handler(int proc);

int main(void)
{
  int example2_base;

  dynClearList();

  if ((example2_base=dynLoadDCM("example2.dcm"))==DYN_FALSE)
     { return 0; }

  dynSetProcHandler(proc_handler);

  if (!dynGetProc(example2_base+PRINT_TEST))
     { printf("ack!"); }

  dynQuit();

  return DYN_TRUE;
}

void *proc_handler(int proc)
{
  if (proc==0)
     {
       return((void *)0x4D41494E);
     }
  else if (proc==1)
     {
       return(&printf);
     }
  return(0);
}

